<template>
  <q-page class="bg-grey-2 q-pa-sm">
    <div class="col-xs-6 col-sm-6 col-md-4 col-lg-3 col-xl-2">
      <q-card class="shadow-up-24 q-pb-xs">
        <q-card-section class="text-white bg-primary">
          <div
            class="text-h6"
            style="text-align: center"
          >
          Información
          </div>
        </q-card-section>
        <q-card-section>
          <q-card class="q-gutter-y-md">
            <q-tabs
              v-model="tabs"
              dense
              class="full-width"
              active-color="accent"
              indicator-color="primary"
            >
            </q-tabs>
            <q-tab-panels v-model="tabs" animated transition-prev="scale" transition-next="scale">
              <q-tab-panel name="personal">
                <div class="text-h6" align="left">Personal</div><br/>
                  <div class="row items-start">
                    <div style="padding-right: 8px;" class="col-xs-6 col-sm-4 col-md-3 col-lg-1 col-xl-1">
                      <q-input lazy-rules v-model="form.name" label="Nombres" :error="$v.form.name.$error" error-message="Dato necesario"/>
                  </div>
                  <div style="padding-right: 8px;" class="col-xs-6 col-sm-4 col-md-3 col-lg-1 col-xl-1">
                      <q-input lazy-rules v-model="form.fullname" label="Apellidos" :error="$v.form.fullname.$error" error-message="Dato necesario"/>
                  </div>
                  <div style="padding-right: 8px;" class="col-xs-6 col-sm-4 col-md-3 col-xl-1">
                    <q-input type="date" lazy-rules v-model="form.date" label="Fecha de Nacimiento" :error="$v.form.date.$error" error-message="Dato necesario"/>
                  </div>
                  <div style="padding-right: 8px;" class="col-xs-6 col-sm-4 col-md-3 col-lg-1 col-xl-1">
                      <q-input mask="###" lazy-rules v-model="form.year" label="Edad" :error="$v.form.year.$error" error-message="Dato necesario"/>
                  </div>
                  <div style="padding-right: 8px;" class="col-xs-6 col-sm-4 col-md-3 col-xl-1">
                    <q-select
                    v-model="form.sexo"
                    :options="sexo"
                    label="Sexo"
                    option-value="value"
                    option-label="label"
                    emit-value
                    map-options
                    :error="$v.form.sexo.$error" error-message="Dato necesario"
                    >
                  </q-select>
                  </div>
                  <div v-if="form.pais === 'VEN'" style="padding-right: 8px;" class="col-xs-6 col-sm-4 col-md-3 col-xl-1">
                    <q-select
                      v-model="form.pais"
                      :options="pais"
                      label="Pais de Nacimiento"
                      option-value="value"
                      option-label="label"
                      emit-value
                      map-options
                      :error="$v.form.pais.$error" error-message="Dato necesario"
                      >
                    </q-select>
                  </div>
                  <div v-if="form.pais !== 'VEN'" style="padding-right: 8px;" class="col-xs-6 col-sm-4 col-md-3 col-xl-1">
                    <q-input
                      v-model="form.pais"
                      label="Pais de Nacimiento"
                      :error="$v.form.pais.$error" error-message="Dato necesario"
                      >
                    </q-input>
                  </div>
                  <div style="padding-right: 8px;" class="col-xs-6 col-sm-4 col-md-3 col-xl-1">
                    <q-input lazy-rules v-model="form.dni" label="Dni" :mask="form.pais === 'VEN' ? 'V-########' : 'E-########'" :error="$v.form.dni.$error" error-message="Dato necesario"/>
                  </div>
                  <div style="padding-right: 8px;" class="col-xs-6 col-sm-4 col-md-3 col-xl-1">
                    <q-select
                    v-model="form.carrera"
                    :options="carrera"
                    label="Carrera a Estudiar"
                    option-value="value"
                    option-label="label"
                    emit-value
                    map-options
                    :error="$v.form.carrera.$error" error-message="Dato necesario"
                    >
                  </q-select>
                  </div>
                  <div style="padding-right: 8px;" class="col-xs-6 col-sm-4 col-md-3 col-xl-1">
                    <q-select
                    v-model="form.civil_state"
                    :options="state"
                    label="Estado Civil"
                    option-value="value"
                    option-label="label"
                    emit-value
                    map-options
                    :error="$v.form.civil_state.$error" error-message="Dato necesario"
                    >
                  </q-select>
                  </div>
                  <div style="padding-right: 8px;" class="col-xs-6 col-sm-4 col-md-3 col-xl-1">
                    <q-input type="email" label="Email" lazy-rules v-model="form.email" :error="$v.form.email.$error" error-message="Email no valido">
                      <q-tooltip>
                        Debes de tener cuidado con este campo ya que aca sera donde se envie toda la informacion
                      </q-tooltip>
                    </q-input>
                  </div>
                  <div style="padding-right: 8px;" class="col-xs-6 col-sm-4 col-md-3 col-xl-1">
                    <q-input v-model="form.phone" label="Telefono" :mask="form.pais === 'VEN' ? '+58 ### ########' : '### ##########'" :error="$v.form.phone.$error" error-message="Dato necesario"/>
                  </div>
                  <div style="padding-right: 8px;" class="col-xs-6 col-sm-4 col-md-3 col-xl-1">
                    <q-input v-model="form.local_phone" label="Telefono Local" :mask="form.pais === 'VEN' ? '+58 ### ########' : '### ##########'" :error="$v.form.local_phone.$error" error-message="Dato necesario"/>
                  </div>
                  <div style="padding-right: 8px;" class="col-xs-6 col-sm-4 col-md-3 col-xl-1">
                    <q-input v-model="form.direction" label="Lugar Nacimiento" :error="$v.form.direction.$error" error-message="Dato necesario"/>
                  </div>
                  <div style="padding-right: 8px;" class="col-xs-12 col-sm-8 col-md-4 col-xl-4">
                    <q-input v-model="form.father_fullname" label="Nombres y Apellidos del Padre" :error="$v.form.father_fullname.$error" error-message="Dato necesario"/>
                  </div>
                  <div style="padding-right: 8px;" class="col-xs-12 col-sm-8 col-md-4 col-xl-4">
                    <q-input v-model="form.mother_fullname" label="Nombres y Apellidos de la Madre" :error="$v.form.mother_fullname.$error" error-message="Dato necesario"/>
                  </div>
                  <div style="padding-right: 8px;" class="col-xs-6 col-sm-4 col-md-3 col-xl-1">
                    <q-input v-model="form.father_phone" label="Tlfn del Padre" :error="$v.form.father_phone.$error" error-message="Dato necesario" mask="+## #############"/>
                  </div>
                  <div style="padding-right: 8px;" class="col-xs-6 col-sm-4 col-md-3 col-xl-1">
                    <q-input v-model="form.mother_phone" label="Tlfn de la Madre" :error="$v.form.mother_phone.$error" error-message="Dato necesario" mask="+## #############"/>
                  </div>
                  <div style="padding-right: 8px;" class="col-xs-6 col-sm-4 col-md-3 col-xl-1">
                    <q-input v-model="form.direction_pais" label="Pais Vivienda" :error="$v.form.direction_pais.$error" error-message="Dato necesario"/>
                  </div>
                  <div style="padding-right: 8px;" class="col-xs-6 col-sm-4 col-md-3 col-xl-1">
                    <q-input v-model="form.direction_state" label="Estado Vivienda" :error="$v.form.direction_state.$error" error-message="Dato necesario"/>
                  </div>
                  <div style="padding-right: 8px;" class="col-xs-6 col-sm-4 col-md-3 col-xl-1">
                    <q-input v-model="form.direction_city" label="Ciudad Vivienda" :error="$v.form.direction_city.$error" error-message="Dato necesario"/>
                  </div>
                  </div>
                  <div align="right">
                    <br/>
                    <br/>
                    <q-btn label="Siguiente" class="bg-negative text-white" @click="VerifyPersonal('academic')"/>
                  </div>
              </q-tab-panel>
              <q-tab-panel name="academic">
                <div class="text-h6" align="left">Academica</div><br/>
                <div class="row items-start">
                  <div style="padding-right: 8px;" class="col-xs-6 col-sm-4 col-md-4 col-xl-2">
                    <q-input lazy-rules v-model="academic.name" label="Plantel" :error="$v.academic.name.$error" error-message="Dato necesario"/>
                  </div>
                  <div style="padding-right: 8px;" class="col-xs-6 col-sm-4 col-md-4 col-xl-2">
                    <q-input lazy-rules v-model="academic.dependency" label="Dependencia" :error="$v.academic.dependency.$error" error-message="Dato necesario"/>
                  </div>
                  <div style="padding-right: 8px;" class="col-xs-6 col-sm-4 col-md-4 col-xl-2">
                    <q-input lazy-rules v-model="academic.especiality" label="Especialidad" :error="$v.academic.especiality.$error" error-message="Dato necesario"/>
                  </div>
                  <div style="padding-right: 8px;" class="col-xs-6 col-sm-4 col-md-4 col-xl-2">
                    <q-input type="date" lazy-rules v-model="academic.year" label="Año" :error="$v.academic.year.$error" error-message="Dato necesario"/>
                  </div>
                  <div style="padding-right: 8px;" class="col-xs-6 col-sm-4 col-md-4 col-xl-2">
                    <q-input lazy-rules v-model="academic.ubicate" label="Ubicación" :error="$v.academic.ubicate.$error" error-message="Dato necesario"/>
                  </div>
                  <div style="padding-right: 8px;" class="col-xs-6 col-sm-4 col-md-4 col-xl-2">
                    <q-input lazy-rules v-model="academic.system" label="Sistema en que culmino" :error="$v.academic.system.$error" error-message="Dato necesario"/>
                  </div>
                  <div class="col-xs-12 col-sm-12 col-md-12 col-xl-12">
                    <q-toggle
                      v-model="visibily"
                      icon="scholl"
                      label="¿Estudios superiores?"
                    />
                  </div>
                  <br/>
                  <template v-if="visibily">
                    <div style="padding-right: 8px;" class="col-xs-6 col-sm-4 col-md-4 col-xl-2">
                      <q-input lazy-rules v-model="academic.superiority_carrera" label="Carrera Superior"/>
                    </div>
                    <div style="padding-right: 8px;" class="col-xs-6 col-sm-4 col-md-4 col-xl-2">
                      <q-input lazy-rules v-model="academic.superiority_insitute" label="Institución"/>
                    </div>
                  </template>
                </div>
                  <div align="right">
                    <br/>
                    <br/>
                    <q-btn label="Atras" @click="VerifyPersonal('religion-1')"/>
                    <q-btn label="Siguiente" style="margin-left: 18px" class="bg-negative text-white" @click="VerifyPersonal('religion')"/>
                  </div>
              </q-tab-panel>
              <q-tab-panel name="religion">
                <div class="text-h6" align="left">Religion</div><br/>
                <template v-if="form.carrer ==='IUNAV'">
                  <div style="padding-right: 8px;" class="col-xs-10 col-sm-7 col-md-4 col-lg-3 col-xl-3">
                    <q-option-group
                      v-model="religion.religion"
                      :options="religions"
                      color="primary"
                      inline
                      @input="Delete()"
                      />
                      <div v-if="religion.religion" class="row items-start">
                        <div style="padding-right: 8px;" class="col-xs-6 col-sm-4 col-md-3 col-lg-1 col-xl-1">
                          <q-input lazy-rules v-model="religion.type" label="Tipo de religion" />
                        </div>
                        <template v-if="religion.type === 'Adventista' || religion.type === 'adventista'">
                          <div style="padding-right: 8px;" class="col-xs-6 col-sm-4 col-md-3 col-lg-1 col-xl-1">
                            <q-input lazy-rules v-model="religion.asociate" label="Asociacion/Misión" />
                          </div>
                          <div style="padding-right: 8px;" class="col-xs-6 col-sm-4 col-md-3 col-lg-1 col-xl-1">
                            <q-input lazy-rules v-model="religion.distitre" label="Distrito" />
                          </div>
                          <div style="padding-right: 8px;" class="col-xs-6 col-sm-4 col-md-3 col-lg-1 col-xl-1">
                            <q-input lazy-rules v-model="religion.sherpherd" label="Pastor" />
                          </div>
                        </template>
                      </div>
                  </div>
                  </template>
                  <template v-if="form.carrer === 'SETAVEN'">
                     <div class="row items-start">
                        <div style="padding-right: 8px;" class="col-xs-6 col-sm-4 col-md-3 col-lg-1 col-xl-1">
                          <q-input lazy-rules v-model="Sherpherd.asociation" label="Asociación" :error="$v.Sherpherd.asociation.$error" error-message="Dato necesario"/>
                        </div>
                          <div style="padding-right: 8px;" class="col-xs-6 col-sm-4 col-md-3 col-lg-1 col-xl-1">
                            <q-input lazy-rules v-model="Sherpherd.distitre" label="Distrito" :error="$v.Sherpherd.distitre.$error" error-message="Dato necesario"/>
                          </div>
                          <div style="padding-right: 8px;" class="col-xs-6 col-sm-4 col-md-3 col-lg-1 col-xl-1">
                            <q-input lazy-rules v-model="Sherpherd.sherpherd" label="Pastor" :error="$v.Sherpherd.sherpherd.$error" error-message="Dato necesario"/>
                          </div>
                          <div>
                            <div style="padding-right: 8px;" class="col-xs-6 col-sm-4 col-md-3 col-lg-1 col-xl-1">
                              <q-toggle lazy-rules v-model="Sherpherd.test_sherpherd" label="¿Cumplio las tareas que le puso el pastor?" :error="$v.Sherpherd.test_sherpherd.$error" error-message="Dato necesario"/>
                            </div>
                            <div style="padding-right: 8px;" class="col-xs-6 col-sm-4 col-md-3 col-lg-1 col-xl-1">
                            <q-toggle lazy-rules v-model="Sherpherd.colport" label="Colporaje (6Meses)" :error="$v.Sherpherd.colport.$error" error-message="Dato necesario"/>
                          </div>
                            <div style="padding-right: 8px;" class="col-xs-6 col-sm-4 col-md-3 col-lg-1 col-xl-1">
                              <q-toggle lazy-rules v-model="Sherpherd.adventist_naciment" label="¿Adventista de Nacimiento?" :error="$v.Sherpherd.adventist_naciment.$error" error-message="Dato necesario"/>
                            </div>
                          </div>
                          <br/>
                          <div style="padding-right: 8px;" class="col-xs-6 col-sm-4 col-md-3 col-lg-1 col-xl-1">
                            <q-input mask="####" lazy-rules v-model="Sherpherd.years_bautizate" label="Años de Bautizado" :error="$v.Sherpherd.years_bautizate.$error" error-message="Dato necesario"/>
                          </div>
                          <div style="padding-right: 8px;" class="col-xs-6 col-sm-4 col-md-3 col-lg-1 col-xl-1">
                            <q-input type ="date" lazy-rules v-model="Sherpherd.bautizate" label="Fecha de Bauutizo" :error="$v.Sherpherd.bautizate.$error" error-message="Dato necesario"/>
                          </div>
                          <div style="padding-right: 8px;" class="col-xs-6 col-sm-4 col-md-3 col-lg-1 col-xl-1">
                            <q-input lazy-rules v-model="Sherpherd.state_bautizate" label="Lugar de Bautizo" :error="$v.Sherpherd.state_bautizate.$error" error-message="Dato necesario"/>
                          </div>
                          <div style="padding-right: 8px;" class="col-xs-6 col-sm-4 col-md-3 col-lg-1 col-xl-1">
                            <q-input lazy-rules v-model="Sherpherd.sherpherd_bautizate" label="Pastor que relizó Bautizo" :error="$v.Sherpherd.sherpherd_bautizate.$error" error-message="Dato necesario"/>
                          </div>
                      </div>
                  </template>
                  <div align="right">
                    <br/>
                    <br/>
                    <q-btn label="Atras" @click="VerifyPersonal('back')"/>
                    <q-btn label="Enviar" style="margin-left: 18px" class="bg-positive text-white" @click="VerifyPersonal('send')"/>
                  </div>
              </q-tab-panel>
            </q-tab-panels>
          </q-card>
        </q-card-section>
      </q-card>
    </div>
  </q-page>
</template>
<script>
import { required, email } from 'vuelidate/lib/validators'
import { mapGetters } from 'vuex'
export default {
  data () {
    return {
      religions: [
        {
          label: 'Si',
          value: true
        },
        {
          label: 'No',
          value: false
        }
      ],
      visibily: false,
      bandSETAVEN: false,
      tabs: 'personal',
      form: {
        phone: '',
        local_phone: '',
        father_fullname: '',
        mother_fullname: '',
        father_phone: '',
        mother_phone: '',
        direction: '',
        direction_pais: '',
        direction_state: '',
        direction_cit: ''
      },
      religion: {},
      academic: {},
      copyForm: [],
      copyReligion: [],
      copyAcademic: [],
      sexo: [
        {
          label: 'Masculino',
          value: 'M'
        },
        {
          label: 'Femenino',
          value: 'F'
        }
      ],
      carreras: [
        {
          label: 'Informatica',
          value: 'Informatica'
        },
        {
          label: 'Admon Personal',
          value: 'Admon Personal'
        },
        {
          label: 'Admon Empresas',
          value: 'Admon Empresas'
        },
        {
          label: 'Educ Prescolar',
          value: 'Educ Prescolar'
        },
        {
          label: 'Lic Teologia',
          value: 'Lic Teologia'
        }
      ],
      pais: [
        {
          label: 'Venezuela',
          value: 'VEN'
        },
        {
          label: 'Otro',
          value: 'E'
        }
      ],
      carrera: [
        {
          label: 'Informatica',
          value: 'Informatica'
        },
        {
          label: 'Admon Personal',
          value: 'Personal'
        },
        {
          label: 'Admon Empresas',
          value: 'Empresas'
        },
        {
          label: 'Educ Prescolar',
          value: 'Prescolar'
        },
        {
          label: 'P. Formacion Teologica',
          value: 'Teologia'
        }
      ],
      copySherpherd: [],
      Sherpherd: {},
      state: [
        {
          label: 'Casado',
          value: 'CASADO'
        },
        {
          label: 'Soltero',
          value: 'SOLTERO'
        }
      ]
    }
  },
  validations: {
    form: {
      name: {
        required
      },
      fullname: {
        required
      },
      date: {
        required
      },
      sexo: {
        required
      },
      pais: {
        required
      },
      carrera: {
        required
      },
      email: {
        required,
        email
      },
      dni: {
        required
      },
      phone: {
        required
      },
      direction: {
        required
      },
      year: {
        required
      },
      local_phone: {
        required
      },
      father_fullname: {
        required
      },
      mother_fullname: {
        required
      },
      father_phone: {
        required
      },
      mother_phone: {
        required
      },
      direction_pais: {
        required
      },
      direction_state: {
        required
      },
      direction_city: {
        required
      },
      civil_state: {
        required
      }
    },
    academic: {
      name: {
        required
      },
      dependency: {
        required
      },
      especiality: {
        required
      },
      year: {
        required
      },
      ubicate: {
        required
      },
      system: {
        required
      }
    },
    Sherpherd: {
      asociation: {
        required
      },
      distitre: {
        required
      },
      sherpherd: {
        required
      },
      test_sherpherd: {
        required
      },
      colport: {
        required
      },
      years_bautizate: {
        required
      },
      adventist_naciment: {
        required
      },
      bautizate: {
        required
      },
      state_bautizate: {
        required
      },
      sherpherd_bautizate: {
        required
      }
    }
  },
  mounted () {
    this.getPersonal()
  },
  computed: {
    ...mapGetters('generals', ['student'])
  },
  methods: {
    async getPersonal () {
      this.$q.loading.show()
      await this.$api.get('GetStudent_id/' + this.student).then(res => {
        this.copyForm = res
        this.form = this.copyForm[0]
        console.log(this.form)
        this.getAcademic()
        console.log(this.form)
        this.getReligions()
        this.getSHerpherd()
      })
    },
    async getSHerpherd () {
      await this.$api.get('GetSherpherd_Academic/' + parseInt(this.form.id)).then(res => {
        console.log(res, 'fdjh')
        this.copySherpherd = res
        this.Sherpherd = this.copySherpherd[0]
        this.$q.loading.hide()
      })
    },
    async getAcademic () {
      await this.$api.get('GetStudent_Academic/' + parseInt(this.form.id)).then(res => {
        this.copyAcademic = res
        this.academic = this.copyAcademic[0]
      })
    },
    async getReligions () {
      await this.$api.get('GetStudent_Religion/' + parseInt(this.form.id)).then(res => {
        this.copyReligion = res
        this.religion = this.copyReligion[0]
      })
    },
    VerifyPersonal (info) {
      if (info === 'academic') {
        this.$v.form.$touch()
        if (this.$v.form.$error) {
          console.log('error')
        } else {
          this.tabs = 'academic'
          console.log(this.form)
        }
      } else if (info === 'religion') {
        this.$v.academic.$touch()
        if (this.$v.academic.$error) {
          console.log('error')
        } else {
          this.tabs = 'religion'
          this.academic.user_id = this.form.id
          console.log(this.academic)
        }
      } else if (info === 'religion-1') {
        this.tabs = 'personal'
      } else if (info === 'back') {
        this.tabs = 'academic'
      } else if (info === 'send') {
        console.log('Preparated send')
        this.$v.academic.$touch()
        if (this.$v.Sherpherd.$error) {
          console.log('error')
        } else {
          try {
            this.$api.post('StudentModify', this.form).then(res => { // Save Personal Documents
              console.log(res)
            })
            this.$api.post('StudentModify_Academic', this.academic).then(res => { // Save Academic Documents
              console.log(res)
            })
            if (this.form.carrer === 'IUNAV') {
              this.$api.post('StudentModify_Religion', this.religion).then(res => { // Save Religions Documents
                console.log(res)
              })
            } else if (this.form.carrer === 'SETAVEN') {
              this.$api.post('StudentModify_Sherpherd', this.Sherpherd).then(res => { // Save Religions Documents for Teology
                console.log(res)
              })
            }
            this.$q.notify({
              color: 'green-4',
              icon: 'done',
              textColor: 'white',
              message: 'Gracias por completar de llenar los datos, ya puedes continuar con el proceso de inscripción'
            })
            this.$router.push('menu')
          } catch (error) {
            console.log('Error in send date')
          }
        }
      }
    },
    Delete () {
      if (this.religion.religion === false) {
        this.religion.type = ''
        this.religion.pais = ''
        this.religion.city = ''
        this.religion.sherpherd = ''
        this.religion.religion = false
      }
    }
  }
}
</script>
